//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit People;

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, Spin, Events;

type
  TPeopleForm = class(TForm)
    Label1: TLabel;
    PictureSpin: TSpinEdit;
    Label2: TLabel;
    FaceSpin: TSpinEdit;
    label3: TLabel;
    MoveSpin: TSpinEdit;
    Label4: TLabel;
    FuncSpin: TSpinEdit;
    Label5: TLabel;
    TextBlockSpin: TSpinEdit;
    Label6: TLabel;
    TextBankSpin: TSpinEdit;
    HiddenCheck: TCheckBox;
    WhenBox: TComboBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Unk1Spin: TSpinEdit;
    Unk2Spin: TSpinEdit;
    Unk3Spin: TSpinEdit;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PictureSpinChange(Sender: TObject);
    procedure FaceSpinChange(Sender: TObject);
    procedure MoveSpinChange(Sender: TObject);
    procedure FuncSpinChange(Sender: TObject);
    procedure TextBlockSpinChange(Sender: TObject);
    procedure TextBankSpinChange(Sender: TObject);
    procedure Unk1SpinChange(Sender: TObject);
    procedure Unk2SpinChange(Sender: TObject);
    procedure Unk3SpinChange(Sender: TObject);
    procedure HiddenCheckClick(Sender: TObject);
    procedure WhenBoxChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  end;

var
  PeopleForm: TPeopleForm = nil;

implementation

uses Main, Math;

{$R *.DFM}

procedure TPeopleForm.FormActivate(Sender: TObject);
begin
Caption := 'People ' + IntToStr(SelectedEvent.Number);
PictureSpin.Value := Peoples[SelectedEvent.Number].Pict;
FaceSpin.Value := Peoples[SelectedEvent.Number].Face;
MoveSpin.Value := Peoples[SelectedEvent.Number].Move;
FuncSpin.Value := Peoples[SelectedEvent.Number].Func;
TextBlockSpin.Value := Peoples[SelectedEvent.Number].TextBlock;
TextBankSpin.Value := Peoples[SelectedEvent.Number].TextBank;
if Peoples[SelectedEvent.Number].Hide = 6 then
 begin
 WhenBox.ItemIndex := Peoples[SelectedEvent.Number].When;
 WhenBox.Enabled := True;
 HiddenCheck.Checked := True;
 end
else
 begin
 HiddenCheck.Checked := False;
 WhenBox.Enabled := False;
 WhenBox.ItemIndex := -1;
 end;
Unk1Spin.Value := Peoples[SelectedEvent.Number].Unk1;
Unk2Spin.Value := Peoples[SelectedEvent.Number].Unk2;
Unk3Spin.Value := Peoples[SelectedEvent.Number].Unk3;
end;

procedure TPeopleForm.FormCreate(Sender: TObject);
var I: Integer;
begin
for I := 0 to 255 do
 begin
 if HideShowIni.ReadString('Hidden/shown',inttostr(I),'') = '' then
 WhenBox.Items.Add(IntToStr(I))
 else
 WhenBox.Items.Add(HideShowIni.ReadString('Hidden/shown',IntToStr(I),''));
 end;
end;

procedure TPeopleForm.PictureSpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].Pict := PictureSpin.Value;
end;

procedure TPeopleForm.FaceSpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].Face := FaceSpin.Value;
end;

procedure TPeopleForm.MoveSpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].Move := MoveSpin.Value;
end;

procedure TPeopleForm.FuncSpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].Func := FuncSpin.Value;
end;

procedure TPeopleForm.TextBlockSpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].TextBlock := TextBlockSpin.Value;
end;

procedure TPeopleForm.TextBankSpinChange(Sender: TObject);
begin
peoples[SelectedEvent.Number].TextBank := TextBankSpin.Value;
end;

procedure TPeopleForm.Unk1SpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].Unk1 := Unk1Spin.Value;
end;

procedure TPeopleForm.Unk2SpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].Unk2 := Unk2Spin.Value;
end;

procedure TPeopleForm.Unk3SpinChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].Unk3 := Unk3Spin.Value;
end;

procedure TPeopleForm.HiddenCheckClick(Sender: TObject);
begin
if HiddenCheck.Checked then
 begin
 peoples[SelectedEvent.Number].Hide := 6;
 WhenBox.ItemIndex := 64;
 peoples[SelectedEvent.Number].When := WhenBox.ItemIndex;
 WhenBox.Enabled := True;
 end
else
 begin
 peoples[SelectedEvent.Number].Hide := 255;
 peoples[SelectedEvent.Number].When := 255;
 WhenBox.Enabled := False;
 end;
end;

procedure TPeopleForm.WhenBoxChange(Sender: TObject);
begin
Peoples[SelectedEvent.Number].When := WhenBox.ItemIndex;
end;

procedure TPeopleForm.FormShow(Sender: TObject);
begin
//try to position event window nicely
if MainForm.EventScrollBox.Width < MainForm.EventBox.Width then
Left := MainForm.MapTree.Width + MainForm.Left + MainForm.EventScrollBox.Width + 32 + Random(32)
else
Left := MainForm.MapTree.Width + MainForm.Left + MainForm.EventBox.Width + 32 + Random(32);
if Left + Width > Screen.WorkAreaRect.Right then
Left := Screen.WorkAreaRect.Right - (Width + 16);
end;

end.
