//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit TryMap;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Events;

type
  TTryForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TryForm: TTryForm;

implementation

uses Main;

{$R *.DFM}

procedure TTryForm.Button1Click(Sender: TObject);
begin
 try
 MapStart := strtoint('$'+Edit1.Text);
 except
 MessageDlg('Please enter valid map starting address, in hexadecimal.',mtWarning,[mbOK],0);
 Exit;
 end;
MapX := SpinEdit1.Value;
MapY := SpinEdit2.Value;
MainForm.Caption := 'Gold Map - Testing map';

MainForm.MapBox.Hint := 'This test map was loaded from ' + Edit1.Text;
MainForm.LoadTileset(SpinEdit3.Value);
//No events
EventsAddr := 0;
 MainForm.EventScrollBox.Hide;
 MainForm.NoEventsLabel.Show;
//no wild pokemon
PokemonStart := 0;
MainForm.GroupBox1.Hide;
 MainForm.GroupBox2.Hide;
 MainForm.GroupBox3.Hide;
 MainForm.GroupBox4.Hide;
 MainForm.NoWildPokemonLabel.Show;

//load map
Rom.Position := MapStart;
if Rom.Size - Rom.Position < MapX *  MapY then
 begin
 MessageDlg('Map is too big to be read from file.',mtWarning,[mbOK],0);
 Abort;
 end;
SetLength(MapData,MapX * MapY);
//Reads map data
Rom.Read(MapData[0],MapX * MapY);

//give MapBox right size
MainForm.MapBox.Height := MapY * 64;
MainForm.MapBox.Width  := MapX * 64;
//Show map
MainForm.DrawMap(MainForm.MapBox.Canvas);
MainForm.MapScrollBox.Show;
MainForm.ReBuildEvents1.Enabled  := False;
MainForm.ReconstructMap1.Enabled := False;
MainForm.MapProperties1.Enabled  := False;
end;

procedure TTryForm.Button2Click(Sender: TObject);
begin
Close;
end;

procedure TTryForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := caFree;
end;

procedure TTryForm.FormCreate(Sender: TObject);
begin
Edit1.Text := IntToHex(MapStart,6);
SpinEdit1.Value := MapX;
SpinEdit2.Value := MapY;
SpinEdit3.Value := LoadedTileset;
end;

end.
