//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit Warp;

interface

uses
  SysUtils, Graphics, Controls, Forms, StdCtrls, Spin, Events, Classes;

type
  TWarpForm = class(TForm)
    Label1: TLabel;
    WarpToSpin: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    MapBankSpin: TSpinEdit;
    MapSpin: TSpinEdit;
    Button1: TButton;
    procedure FormActivate(Sender: TObject);
    procedure WarpToSpinChange(Sender: TObject);
    procedure MapBankSpinChange(Sender: TObject);
    procedure MapSpinChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WarpForm: TWarpForm = nil;

implementation

uses Main;

{$R *.DFM}

procedure TWarpForm.FormActivate(Sender: TObject);
begin
Caption := 'Warp ' + IntToStr(SelectedEvent.Number);
WarpToSpin.Value  := Warps[SelectedEvent.Number].WarpTo;
MapBankSpin.Value := Warps[SelectedEvent.Number].MapBank;
MapSpin.Value     := Warps[SelectedEvent.Number].Map;
end;

procedure TWarpForm.WarpToSpinChange(Sender: TObject);
begin
Warps[SelectedEvent.Number].WarpTo := WarpToSpin.Value;
end;

procedure TWarpForm.MapBankSpinChange(Sender: TObject);
begin
Warps[SelectedEvent.Number].MapBank := MapBankSpin.Value;
end;

procedure TWarpForm.MapSpinChange(Sender: TObject);
begin
Warps[SelectedEvent.Number].Map := MapSpin.Value;
end;

procedure TWarpForm.FormCreate(Sender: TObject);
begin
Left := Screen.WorkAreaRect.Right - (Width + 16);
end;

procedure TWarpForm.FormShow(Sender: TObject);
begin
//try to position event window nicely
if MainForm.EventScrollBox.Width < MainForm.EventBox.Width then
Left := MainForm.MapTree.Width + MainForm.Left + MainForm.EventScrollBox.Width + 32 + Random(32)
else
Left := MainForm.MapTree.Width + MainForm.Left + MainForm.EventBox.Width + 32 + Random(32);
if Left + Width > Screen.WorkAreaRect.Right then
Left := Screen.WorkAreaRect.Right - (Width + 16);
end;

procedure TWarpForm.Button1Click(Sender: TObject);
begin
MainForm.LoadMap(MapBankSpin.Value,MapSpin.Value);
MainForm.PageControl1.ActivePageIndex := 1;
end;

end.
